#include <string.h>
#include "Memory.h"
#include "geometry.h"
#include "test.h"
#include "client.h"
#include "kick.h"
#include "dribble.h"
#include "behave.h"
#include "vW_Behaviour.h"

vW_Behaviour::vW_Behaviour(bool _organizer)
    : organizer(_organizer)
{}

vW_Behaviour::~vW_Behaviour()
{}

// Grundverhalten
void vW_Behaviour::Behave()
{
    if ( Mem->MyConf() ) 
    {
	if ( Mem->BallKickable() )
	{
	  kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	}
	else
	    get_ball();   
    }
    else
	turn(90);
}


int vW_Behaviour::evaluatePointToPassBallFromPoint(Vector pos,Vector Point) 
// pass von point nach pos
{
    Mem->update_offside_lines();
    float distance = Point.dist(pos);
    int eva=100-(int)(fabs(20-distance)*5); 
    eva-=20*Mem->NumOpponentsInCone(1,pos,Point);
    eva-=200*Mem->NumOpponentsInCone(.5,pos,Point);
    eva-=(int)(20*(fabs(pos.dist(Mem->MarkerPosition(Mem->RM_Their_Goal)))-
		   fabs(Point.dist(Mem->MarkerPosition(Mem->RM_Their_Goal)))));
    eva-=(int)(20*(Mem->NumOpponentsWithin(10,pos)-Mem->NumOpponentsWithin(10,Point)));
    if(Point.x<Mem->MarkerPosition(Mem->RM_My_PC_Flag).x+10&&
       ((Point.y<0&&Point.y<pos.y-5)||
	(Point.y>0&&Point.y>pos.y+5)||
	Point.x>pos.x))
	eva-=1000;
    return eva;
}


Unum vW_Behaviour::findTeammateToPassBall(int evalBase)
{
    int eva =0;
    Unum BestTeammate=0;
    for(int i=2; i<=Mem->SP_team_size; i++){
	if(Mem->TeammatePositionValid(i) && i!=Mem->MyNumber){
	    int evatemp=
		evaluateTeammateToPassBall(Mem->PlayerAbsolutePosition(Mem->MySide,i),
					   i);
	    if(eva<evatemp){
		BestTeammate=i;
		eva=evatemp;
	    }
	}
    }   
    if(eva>evalBase)
	return BestTeammate;
    else
	return 0;
}

float vW_Behaviour::PassToTeammateKickPower(Unum Player)
{
    float Power= 2*Mem->MyPos().dist2(Mem->PlayerAbsolutePosition(Mem->MySide,Player));
    if(Power>100)
	return 100;
    else 
	return Power;
}


int vW_Behaviour::goodPointToScore()
{
    
    if(fabs(Mem->MyPos().x-Mem->MarkerPosition(Mem->RM_Their_Goal).x)<5)
      return 1;

    if(Mem->MyPos().dist2(Mem->MarkerPosition(Mem->RM_Their_Goal))<400&&
       !Mem->NumOpponentsInCone(.5,Mem->MarkerPosition(Mem->RM_Their_Goal),
				Mem->MyPos())) 
	return 1;
    if(Mem->TheirGoalieArea.IsWithin(Mem->MyPos())) return 1;
    
    if(Mem->MyPos().dist2(Mem->MarkerPosition(Mem->RM_Their_Goal))<200 && 
       Mem->NumOpponentsInCone(.5,Mem->MarkerPosition(Mem->RM_Their_Goal),
			       Mem->MyPos())<3)
	return 1;
    else
	if(Mem->MyPos().dist2(Mem->MarkerPosition(Mem->RM_Their_Goal))<300 && 
	   Mem->NumPlayersInCone(.5,Mem->MarkerPosition(Mem->RM_Their_Goal),
				 Mem->MyPos())>4)
	    return 1;
	else
	    if(BallCatchableForOpponent())
		return 1;
	    else
		if(Mem->TheirPenaltyArea.IsWithin(Mem->MyPos())&&
		   Mem->NumOpponentsWithin(Mem->SP_kickable_area))
		    return 1;
		else
		    return 0;
} 

void vW_Behaviour::Score()
{
    AngleDeg kickAngle;
    if(Mem->OpponentPositionValid(1)){

        /*Wenn die Position des Torwarts bekannt ist soll  in die Torecke, 
	  bei der der Winkel zwischen der Torecke, dem Spieler und dem Torwart 
	  am groessten ist. */
	Vector LinkerPfosten =Vector(Mem->MarkerPosition(Mem->RM_Their_Goal).x,
				     Mem->MarkerPosition(Mem->RM_Their_Goal).y
				     +((Mem->SP_goal_width/2)-2));
	Vector RechterPfosten =Vector(Mem->MarkerPosition(Mem->RM_Their_Goal).x,
				      Mem->MarkerPosition(Mem->RM_Their_Goal).y
				      -((Mem->SP_goal_width/2)-2));
	
	kickAngle= fabs(Mem->OpponentAngleFromBody(1)-
			Mem->AngleToFromBody(LinkerPfosten)) <
	    fabs(Mem->OpponentAngleFromBody(1)-
		 Mem->AngleToFromBody(RechterPfosten)) ? 
	    Mem->AngleToFromBody(RechterPfosten) : 
	    Mem->AngleToFromBody(LinkerPfosten);
    } else {
	
	/* sonst wird genau auf die Mitte des Tores gezielt. */
	
	kickAngle=Mem->MarkerAngleFromBody(Mem->RM_Their_Goal);
    }
    kick(100,kickAngle);
}
 
inline int vW_Behaviour::evaluateTeammateToPassBall(Vector pos,Unum Player)
{
    return evaluatePointToPassBallFromPoint(pos,Mem->MyPos());
}
   


void vW_Behaviour::go_to_point_backward(Vector pt, float dash_power)
{
    Vector mirrorpoint;
    
    mirrorpoint = 2 * Mem->MyPos() - pt;
    

    if (Mem->MyPos().x<pt.x)
	go_to_point(pt, 0.1,10,DT_none);
    

    if (dash_power > 0)
	dash_power = -dash_power;
    
    if (dash_power < -30)
	dash_power = -30;
    

    if ((fabs(Mem->AngleToFromBody(mirrorpoint))<(M_PI/32)) ||
	(fabs(Mem->AngleToFromBody(mirrorpoint))<(2 * M_PI-(M_PI/32))))
	dash(dash_power);
    else
	face_only_body_to_point(mirrorpoint);
}




int vW_Behaviour::GoToPointFaceBall(Vector Point, float DashPower, float buff)
{
    if(Mem->NumPlayersInCone(0.2, Point.SetLength(0.25), Mem->MyPos()))
	Point = Mem->MyPos()+(Point - Mem->MyPos()).rotate(M_PI/2);
    if(Mem->MyPos().dist2(Point)>buff){
	if((fabs((Point - Mem->MyPos()).dir()-
		 (Mem->BallAbsolutePosition() - Mem->MyPos()).dir())>M_PI/2)&&
	   Mem->BallPositionValid())
	{    
	    if(fabs(Mem->MyBodyAng()-(Mem->MyPos()-Point).dir())<1){
		face_only_neck_to_ball();
		dash(-30);
	    } else {
		AngleDeg target_rel_ang = 
		    Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)>0 ?
		    (Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)+M_PI) :
		    (Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)+M_PI);
		face_only_neck_to_ball();   
		turn( target_rel_ang );
	    }
	}else{
	    if(fabs(Mem->MyBodyAng()-(Point - Mem->MyPos()).dir())<1){
		if(Mem->BallPositionValid()) face_only_neck_to_ball();
		dash(Mem->CorrectDashPowerForStamina(DashPower));
	    } else {
		AngleDeg target_rel_ang = 
		    Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point);
		if(Mem->BallPositionValid()) face_only_neck_to_ball();  
		turn( target_rel_ang );
	    }
	}
	return 0;
	
    } else {
	return 1;
    }
    
}

int vW_Behaviour::GoToPointFaceOpponent(Vector Point, Unum Player, float DashPower, 
					float buff)
{
    if(Mem->NumPlayersInCone(0.2, Point.SetLength(0.25), Mem->MyPos()))
	Point = Mem->MyPos()+(Point - Mem->MyPos()).rotate(90);
    if(Mem->MyPos().dist2(Point)>buff){
	if((fabs((Point - Mem->MyPos()).dir()-
		 (Mem->OpponentAbsolutePosition(Player) - Mem->MyPos()).dir())>90)&&
	   Mem->OpponentPositionValid(Player))
	{    
	    if(fabs(Mem->MyBodyAng()-(Mem->MyPos()-Point).dir())<1){
		face_only_neck_to_opponent(Player);
		dash(Mem->CorrectDashPowerForStamina(-DashPower));
	    } else {
		AngleDeg target_rel_ang = 
		    Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)>0 ?
		    (Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)+M_PI) :
		    (Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point)+M_PI);
		face_only_neck_to_opponent(Player);  
		turn( target_rel_ang );
	    }
	}else{
	    if(fabs(Mem->MyBodyAng()-(Point - Mem->MyPos()).dir())<1){
		if(Mem->OpponentPositionValid(Player)) 
		    face_only_neck_to_opponent(Player);
		dash(Mem->CorrectDashPowerForStamina(DashPower));
	    } else {
		AngleDeg target_rel_ang = 
		    Mem->PredictedPointRelAngFromBodyWithQueuedActions(Point);
		if(Mem->OpponentPositionValid(Player)) 
		    face_only_neck_to_opponent(Player); 
		turn( target_rel_ang );
	    }
	}
	return 0;
	
    } else {
	return 1;
    }
    
}

void vW_Behaviour::searchBall(int walk){
    if(Mem->OffsidePosition(SearchBallPosition.x, Mem->TheirSide) || 
       !Mem->FieldRectangle.IsWithin(SearchBallPosition))
	{
	SearchBallPosition=Vector(SearchBallPosition.x+(random()/walk-walk/2),
				  SearchBallPosition.y+(random()/walk-walk/2));
	return;
	}
    
    if(Mem->InOffsidePosition()){
	GoToPointFaceBall(Vector(Mem->their_offside_line-5,Mem->MyPos().y));
	return;
    }
    if(GoToPointFaceBall(SearchBallPosition)){
	SearchBallPosition=Vector(SearchBallPosition.x+(random()/walk-walk/2),
				  SearchBallPosition.y+(random()/walk-walk/2));
    }
    
    
    
}
Vector vW_Behaviour::GoodPositionToReceiveBall(int x){
    Vector Ball = Mem->BallAbsolutePosition();
    int eva =(evaluatePointToPassBallFromPoint(BestPositionToReceiveBall,
					       Ball)
	      -(int)fabs(BestPositionToReceiveBall.y-MyStartPosition.y)*10
	      -200*Mem->NumTeammatesWithin(15,BestPositionToReceiveBall)
	      -((int)(fabs((BestPositionToReceiveBall.x-Ball.x)-x))*20));
	      Vector Position = BestPositionToReceiveBall;
    if(BestPositionToReceiveBall.x>Mem->my_offside_line) BestPositionToReceiveBall.x=Mem->my_offside_line;
    if(BestPositionToReceiveBall.x<defense_line) BestPositionToReceiveBall.x=defense_line;
    for(int i=0;i<80;i++){
	Vector temp(Position.x+(random()%60)-30,Position.y+(random()%60)-30);
	if(temp.x>Mem->my_offside_line) temp.x=Mem->my_offside_line;
        if(temp.x<defense_line) temp.x=defense_line;
	int evatemp=(evaluatePointToPassBallFromPoint(temp,Ball)
		     -(int)fabs(temp.y-MyStartPosition.y)*10
		     -200*Mem->NumTeammatesWithin(15,temp)
		     -((int)(fabs((temp.x-Ball.x)-x))*20));
	if(Mem->FieldRectangle.IsWithin(temp)&& eva < evatemp){
	    eva=evatemp;
	    Position=temp;
	}
    }
    return Position;
}

void vW_Behaviour::say(char *msg)
{
    if(Mem->CurrentTime%4==0){
	char *temp=new char[Mem->SP_say_msg_size];
	memset(temp,0,250);
	if(Mem->CurrentTime-Mem->team_pass_time<10)
	    sprintf(temp,"vwm %d %.2f %.2f %.2f %.2f %.2f %.2f pass %d",
		    Mem->MyNumber,
		    Mem->MyPos().x,
		    Mem->BallAbsolutePosition().x,
		    Mem->MyPos().y,
		    Mem->BallAbsolutePosition().y,
		    Mem->BallHPConf(),
		    Mem->BallDistance(),
		    Mem->team_receiver);
	else
	    sprintf(temp,"vwm %d %.2f %.2f %.2f %.2f %.2f %.2f",
		    Mem->MyNumber,
		    Mem->MyPos().x,
		    Mem->BallAbsolutePosition().x,
		    Mem->MyPos().y,
		    Mem->BallAbsolutePosition().y,
		    Mem->BallHPConf(),
		    Mem->BallDistance());
	strcat(temp,msg);
        // cout << "say:" << temp << endl;
	Say(temp);
	delete[] temp;
    }   
}

void vW_Behaviour::organize(char *msg)
{
    static int say_msg_size;
    static char temp1[1024];

    if(Mem->CurrentTime%4==2){
        say_msg_size=Mem->SP_say_msg_size;

	char *temp2=new char[say_msg_size];
	memset(temp1,0,1024);
	memset(temp2,0,say_msg_size);

	sprintf(temp1,"vwm %d %.2f %.2f %.2f %.2f %.2f %.2f",
		Mem->MyNumber,
		Mem->MyPos().x,
		Mem->BallAbsolutePosition().x,
		Mem->MyPos().y,
		Mem->BallAbsolutePosition().y,
		Mem->BallHPConf(),
		Mem->BallDistance());

	strncat(temp1,msg,1024);
	strncpy(temp2,temp1,say_msg_size);
	//cout << "organize:" << temp2 << endl;
	Say(temp2);
	delete[] temp2;
    }
}

void vW_Behaviour::kick_in()
{
    if (reachedPosition)
    {
	
	if (!Mem->BallKickable())
	{
	    reachedPosition=false;
	    scan_field_with_body();
	    return;    
	}
	
	/* Gibt es einen besser postierten Mitspieler,
	   wird der angepasst */
	
	int TeammateToPassBall=findTeammateToPassBall();
	
	if(TeammateToPassBall)
	{
	    pass_ball(TeammateToPassBall);
	    reachedPosition = false;
	    return;
	} 
	else 
	{
	    scan_field_with_body();
	    return;
	}
    }
    else 
    {
	if (Mem->BallKickable() &&
	    (Mem->MyPos().Behind(Mem->BallAbsolutePosition()) &&
	     fabs(Mem->MyPos().y)>fabs(Mem->BallAbsolutePosition().y)))
	{ 
	    reachedPosition=true;
	    scan_field_with_body();
	    return;
	} 
	else 
	{
	    float bap = Mem->BallAbsolutePosition().y;
	    Vector kickingpoint=Vector(Mem->BallAbsolutePosition().x-0.5,
				       bap+((fabs(bap)/bap)*0.5));
	    go_to_point(kickingpoint, 0.1, 20, DT_none);
	    return;
	}
    }
}


/*********************************/
/* Input fuer das Bayessche Netz */
/*********************************/


/*** die Zonen nach Modell 1 ***/

bool vW_Behaviour::InZone1_Mode1(Vector Pos)
{
    if (Pos.dist(Mem->RM_Their_Goal)<=Mem->SP_goal_area_width/2.0)
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone2_Mode1(Vector Pos)
{
    if ((Pos.x>Mem->MarkerX(Mem->RM_Their_PC_Flag)) &&
	(fabs(Pos.y) < Mem->SP_penalty_area_width/2.0) &&
	(Pos.dist(Mem->RM_Their_Goal)<=Mem->SP_goal_area_width/2.0))
	return TRUE;
    else 
	return FALSE;
}

bool vW_Behaviour::InZone3_Mode1(Vector Pos)
{
    if ((Pos.x>Mem->MarkerX(Mem->RM_Their_PC_Flag)) &&
	!(fabs(Pos.y) < Mem->SP_penalty_area_width/2.0))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone4_Mode1(Vector Pos)
{
    if ((Pos.x>0) &&
	(Pos.dist(Mem->RM_Their_Goal)<=43) &&
	(Pos.x<Mem->MarkerX(Mem->RM_Their_PC_Flag)))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone5_Mode1(Vector Pos)
{
    if ((Pos.x>0) && 
	(Pos.dist(Mem->RM_Their_Goal)>43))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone6_Mode1(Vector Pos)
{
    if (Pos.x<=0)
	return TRUE;
    else
	return FALSE;
}



/*** die Zonen nach Modell 2 ***/


bool vW_Behaviour::InZone1_Mode2(Vector Pos)
{
    if (Pos.dist(Mem->RM_Their_Goal)<=Mem->SP_goal_area_width/2.0)
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone2_Mode2(Vector Pos)
{
    if ((Pos.dist(Mem->RM_Their_Goal)<Mem->SP_penalty_area_width/2.0) &&
	(Pos.dist(Mem->RM_Their_Goal)>Mem->SP_goal_area_width/2.0))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone3_Mode2(Vector Pos)
{
    if ((Pos.x>Mem->MarkerX(Mem->RM_Their_PC_Flag)) &&
	(Pos.dist(Mem->RM_Their_Goal)>Mem->SP_penalty_area_width/2.0))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone4_Mode2(Vector Pos)
{
    if ((Pos.x>0) &&
	(Pos.dist(Mem->RM_Their_Goal)<=43) &&
	(Pos.x<Mem->MarkerX(Mem->RM_Their_PC_Flag)))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone5_Mode2(Vector Pos)
{
    if ((Pos.x>0) && 
	(Pos.dist(Mem->RM_Their_Goal)>43))
	return TRUE;
    else
	return FALSE;
}

bool vW_Behaviour::InZone6_Mode2(Vector Pos)
{
    if (Pos.x<=0)
	return TRUE;
    else
	return FALSE;
}



/*** Liefert die Zonennummer entsprechend des angegebenen Modells ***/

int vW_Behaviour::WhereIsBall(int mode)
{
    Vector BallPos = Mem->BallAbsolutePosition();

    int ret;

    if (mode==1)
    {
	if (InZone1_Mode1(BallPos))
	    ret = 1;
	if (InZone2_Mode1(BallPos))
	    ret = 2;
	if (InZone3_Mode1(BallPos))
	    ret = 3;
	if (InZone4_Mode1(BallPos))
	    ret = 4;
	if (InZone5_Mode1(BallPos))
	    ret = 5;
	if (InZone6_Mode1(BallPos))
	    ret = 6;
	return ret;
    } 
    else
	if (mode==2)
	{
	    if (InZone1_Mode2(BallPos))
		ret = 1;
	    if (InZone2_Mode2(BallPos))
		ret = 2;
	    if (InZone3_Mode2(BallPos))
		ret = 3;
	    if (InZone4_Mode2(BallPos))
		ret = 4;
	    if (InZone5_Mode2(BallPos))
		ret = 5;
	    if (InZone6_Mode2(BallPos))
		ret = 6;
	    return ret;
	}
	else
	    return 0;
}



/*** Anzahl der Gegner in einem Unmkreis von 'Dist' ***/


int vW_Behaviour::NumOpponentsInDistance(float Dist)
{
    return Mem->NumOpponentsWithin(Dist, Mem->MyPos());
}


/*** Rueckgabe des Bereichs in dem die Gegnerzahl liegt ***/


int vW_Behaviour::OpponentsInDistance(float Dist)
{
    switch(NumOpponentsInDistance(Dist))
    {
    case 0:
	return 0;
	break;
	
    case 1:
	return 1;
	break; 

    case 2:
	return 2;
	break;

    case 3:
	return 2;
	break;

    default:
	return 3;
	break;
    }
}


/*** Anzahl der Mitspieler in einem Unmkreis von 'Dist' ***/


int vW_Behaviour::NumTeammatesInDistance(float Dist)
{
    return Mem->NumTeammatesWithin(Dist, Mem->MyPos());
}


/*** Rueckgabe des Bereichs in dem die Gegnerzahl liegt ***/


int vW_Behaviour::TeammatesInDistance(float Dist)
{
    switch(NumTeammatesInDistance(Dist))
    {
    case 0:
	return 0;
	break;
	
    case 1:
	return 1;
	break; 

    case 2:
	return 2;
	break;

    case 3:
	return 2;
	break;

    default:
	return 3;
	break;
    }
}



/*** Kann der generische Torwart den Ball catchen ? ***/

bool vW_Behaviour::BallCatchableForOpponent()
{
    if (Mem->OpponentPositionValid(1)&&((InZone2_Mode1(Mem->OpponentAbsolutePosition(1))) ||
	 (InZone1_Mode1(Mem->OpponentAbsolutePosition(1)))) &&
	(Mem->OpponentPositionValid(1)) &&
	((Mem->OpponentAbsolutePosition(1).dist(Mem->BallAbsolutePosition()))<=
	 (Mem->SP_catch_area_l)*1.5))
	return TRUE;
    else
	return FALSE;
}



/*** In welchem Bereich liegt meine Stamina ? ***/

int vW_Behaviour::MyStaminaArea()
{
    float rel_stamina;
    int ret;

    rel_stamina=(Mem->MyStamina()/Mem->SP_stamina_max);
    
    if (rel_stamina>=0.75)
	ret=0;
    else
	if (rel_stamina>=0.5)
	    ret=1;
	else
	    if (rel_stamina>=0.25)
		ret=2;
	    else
		if (rel_stamina>=0)
		    ret=3;
    return ret;
}




/*** Wieviele Gegner sind im Schusskegel ? ***/

/* Dafuer Vergleich zwischen den Winkeln zu den beiden Pfosten;
   Liegt der Winkel eines Gegenspielers dazwischen, muss er innerhalb des
   Schusskegels sein */

int vW_Behaviour::OpponentsInShootingCone()
{
    int count;

    Vector leftpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			     Mem->MarkerY(Mem->RM_Their_Goal)+Mem->SP_goal_width/2.0);
    
    Vector rightpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			      Mem->MarkerY(Mem->RM_Their_Goal)-Mem->SP_goal_width/2.0);
    
    float angle_left_post = Mem->AngleToFromBody(leftpost);
    
    float angle_right_post = Mem->AngleToFromBody(rightpost);
    
    for (Unum opp = 2; opp <= Mem->SP_team_size; opp++) 
    {
	if (!Mem->OpponentPositionValid(opp))
	    continue;
	float opp_angle = Mem->AngleToFromBody(Mem->OpponentAbsolutePosition(opp));
	if (((angle_left_post <= opp_angle) && 
	     (angle_right_post >= opp_angle)) ||
	    ((angle_right_post <= opp_angle) && 
	     (angle_left_post >= opp_angle))) 
	    count++;
    }
    
    switch(count)
    {
    case 0:
	return 0;
	break;
	
    case 1:
	return 1;
	break; 
	
    case 2:
	return 2;
	break;
	
    case 3:
	return 2;
	break;
	
    default:
	return 3;
	break;
    }
}




int vW_Behaviour::OpenGoal()
{
    /*Vector leftpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			     Mem->MarkerY(Mem->RM_Their_Goal)+Mem->SP_goal_width/2.0);
    
    Vector rightpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			      Mem->MarkerY(Mem->RM_Their_Goal)-Mem->SP_goal_width/2.0);

    Vector Left_Goalie_Point=Vector(Mem->OpponentAbsolutePosition(1).x,
				    Mem->OpponentAbsolutePosition(1).y-Mem->SP_catch_area_l);
    
    Vector Right_Goalie_Point=Vector(Mem->OpponentAbsolutePosition(1).x,
				    Mem->OpponentAbsolutePosition(1).y+Mem->SP_catch_area_l);
    
    */ /*
    Line goalie_line = Mem->LineFromTwoPoints(Left_Goalie_Point, Right_Goalie_Point);
    
    Line left_post_line = Mem->LineFromTwoPoints(Mem->BallAbsolutePosition(),
						 leftpost);
    
    Line right_post_line = Mem->LineFromTwoPoints(Mem->BallAbsolutePosition(),
						 rightpost);
    */

    float left_open = 0.0;
    float right_open = 0.0;
    


    float open = left_open + right_open;

    int ret;
    
    if (open > 0.5)
	ret=0;
    else
	if (open > 0.3)
	    ret=1;
	else 
	    ret=2;
    
    return ret;
}




/*** Winkel zum Tor ***/


int vW_Behaviour::AngleToGoal()
{
    Vector ballPos = Mem->BallAbsolutePosition();
    

    Vector leftpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			     Mem->MarkerY(Mem->RM_Their_Goal)+Mem->SP_goal_width/2.0);
    
    Vector rightpost = Vector(Mem->MarkerX(Mem->RM_Their_Goal),
			      Mem->MarkerY(Mem->RM_Their_Goal)-Mem->SP_goal_width/2.0);

    float A = Mem->SP_goal_width;
    float B = ballPos.dist(leftpost);
    float C = ballPos.dist(rightpost);

    float temp1 = -(((A * A) - (B * B) - (C * C))/(2 * B * C));
    
    float temp2 = acos(temp1);

    float goalangle = (temp2 * 180)/ M_PI;
    
    int ret;
    
    if (goalangle > 45.0)
	ret=0;
    else
	if (goalangle > 30.0)
	    ret=1;
	else
	    if (goalangle > 10.0)
		ret=2;
	    else
		ret=3;

    return ret;
}



/********************************/
/*** Bayes Netz fuer Stuermer ***/
/********************************/


//Funktion liefert die entgltige Entscheidung

int vW_Behaviour::NextAction() {
	
    // Die ist praktisch unsere Utility. Schieen wird hher bewertet als passen und laufen.
    
    shoot_chance = 1;	
    pass_chance = 1;
    run_chance = 1;
	
    // Zone rechnet alles durch und modifiziert die Globalen Variablen shoot_chance, pass_chance
    // und run_chance.
    
    zone();
	
    //Entscheidung was der grte Wert ist. und Rckgabe der Entscheidung
    
    if ((shoot_chance > pass_chance ) && (shoot_chance > run_chance)) {
		
	return 0;
    }
    else {	
	if ((pass_chance > run_chance)) {
	    
	    return 1;
	}	
	else {
		    return 2;
	}
    }
}


// Anhand der Zone wo sich der Ball befindet (bzw. der Spieler mit Ball) wird
// entschieden welche weitern Wahrscheinlichkeiten relevant sind.
// Ab Zone 5 wird nicht mehr die chance des Schues berechnet.

void vW_Behaviour::zone () {
    
    int zone = WhereIsBall(1);  //Der Wert mu noch angepat werden
	
    switch (zone) {
	
    case 1:
	shoot_chance = shoot_chance * 1; 
	pass_chance = pass_chance * 0.5;
	run_chance = run_chance * 0.4;
	
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
	shoot_OpponentInCone();
	shoot_OpenGoal();
	shoot_AngleToGoal();
	
	break;
	
    case 2:
	shoot_chance = shoot_chance * 0.95; 
	pass_chance = pass_chance * 0.7;
	run_chance = run_chance * 0.5;
	
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
	shoot_OpponentInCone();
	shoot_OpenGoal();
	shoot_AngleToGoal();
			
	break;
			
    case 3:
	shoot_chance = shoot_chance * 0.6; 
	pass_chance = pass_chance * 1;
	run_chance = run_chance * 0.6;
			
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
	shoot_OpponentInCone();
	shoot_OpenGoal();
	shoot_AngleToGoal();
	
	break;
			
    case 4:
	shoot_chance = shoot_chance * 0.5;
	pass_chance = pass_chance * 0.7;
	run_chance = run_chance * 0.7;
			
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
	shoot_OpponentInCone();
	shoot_OpenGoal();
	shoot_AngleToGoal();
	
	break;
		
		
    case 5:
	shoot_chance = shoot_chance * 0;
	pass_chance = pass_chance * 1;
	run_chance = run_chance * 1;
			
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
			
	break;
			
    case 6: 
	shoot_chance = shoot_chance * 0;
	pass_chance = pass_chance * 1;
	run_chance = run_chance * 1;
			
	OpponentsInDistance();
	stateGoalie();
	stamina();
	pass_TeammatesCount();
	
	break;
    }
}

// Gegner die sich in der nhe aufhalten.
// Hat einflu auf Passen und Laufen

void vW_Behaviour::OpponentsInDistance() {
	
    int pass_OpCount = OpponentsInDistance(17); // Wert mu noch gendert werden
    int run_OpCount = OpponentsInDistance(9); // Wert mu noch gendert werden
    
    switch (pass_OpCount) {
	
    case 0:
	pass_chance = pass_chance * 0.5;
	
	break;

    case 1:
	pass_chance = pass_chance * 0.7;
	
	break;
	
    case 2:
	pass_chance = pass_chance * 0.7;
			
	break;
	
    case 3:
	pass_chance = pass_chance * 0.7;
	
	break;
    }

    switch (run_OpCount) {
		
    case 0:
	run_chance = run_chance * 0.9;
	
	break;

    case 1:
	run_chance = run_chance * 0.7;
		    
	break;
		
    case 2:
	run_chance = run_chance * 0.6;
			
	break;
		
    case 3:
	run_chance = run_chance * 0.4;
			
	break;
    }
}


//Status des Torwartes

void vW_Behaviour::stateGoalie() {
	
    if (BallCatchableForOpponent()) {
	
	shoot_chance = shoot_chance * 1; 
	pass_chance = pass_chance * 1; 
	run_chance = run_chance * 0.4;   
    } 
	
    else {
	shoot_chance = shoot_chance * 1;
	pass_chance = pass_chance * 1; 
	run_chance = run_chance * 1;     
    }
}


//Auswirkung unseres Stamina zustandes

void vW_Behaviour::stamina() {
	
    int stamina = MyStaminaArea();
    
    switch(stamina) {
		
    case 0:
	shoot_chance = shoot_chance * 1;
	pass_chance = pass_chance * 0.8;
	run_chance = run_chance * 1;
			
	break;
			
    case 1:
	shoot_chance = shoot_chance * 0.9;
	pass_chance = pass_chance * 0.8;
	run_chance = run_chance * 0.9;
			
	break;
		
    case 2:
	shoot_chance = shoot_chance * 0.8;
	pass_chance = pass_chance * 0.9;
	run_chance = run_chance * 0.6;
			
	break;
		
    case 3:
	shoot_chance = shoot_chance * 0.7;
	pass_chance = pass_chance * 1;
	run_chance = run_chance * 0.2;
			
	break;
    }
}

	
//Eigene Spieler im Umkreis

void vW_Behaviour::pass_TeammatesCount() {
	
    int count_Teammates = TeammatesInDistance(17); //Mu noch gendert werden
	
    switch(count_Teammates) {
		
    case 0:
	pass_chance = pass_chance * 0.15;
			
	break;
		
    case 1:
	pass_chance = pass_chance * 0.7;
			
	break;
		
    case 2:
	pass_chance = pass_chance * 0.95;
			
	break;
		
    case 3:
	pass_chance = pass_chance * 1;
			
	break;
    }
}


//Gegenspieler im Schuwinkel

void vW_Behaviour::shoot_OpponentInCone() {
	
    int count_Opponent = OpponentsInShootingCone();
	
    switch(count_Opponent) {
		
    case 0:
	shoot_chance = shoot_chance * 1;
			
	break;
			
    case 1:
	shoot_chance = shoot_chance * 0.75;
			
	break;
			
    case 2:
	shoot_chance = shoot_chance * 0.4;
			
	break;
		
    case 3:
	shoot_chance = shoot_chance * 0.1;
			
	break;
    }
}

//Freier Raum im Tor...

void vW_Behaviour::shoot_OpenGoal() {

    int freeGoalSpace = OpenGoal();
    
    switch(freeGoalSpace) {
		
    case 0:
	shoot_chance = shoot_chance * 1;
	
	break;
		
    case 1:
	shoot_chance = shoot_chance * 0.9;
			
	break;
		
    case 2:
	shoot_chance = shoot_chance * 0.7;
			
	break;
    }
}

//Schuwinkel

void vW_Behaviour::shoot_AngleToGoal() {
	
    int angle = AngleToGoal();
	
    switch(angle) {
		
    case 0:
	shoot_chance = shoot_chance * 1;
			
	break;
			
    case 1:
	shoot_chance = shoot_chance * 0.9;
			
	break;
		
    case 2:
	shoot_chance = shoot_chance * 0.65;
			
	break;	
			
    case 3:
	shoot_chance = shoot_chance * 0,4;
			
	break;
    }
}


		
int vW_Behaviour::kickPower(AngleDeg KickAngle)
{
    float dist=DistanceToNextOpponentInCone(1
					    ,Mem->MyPos()+Vector(20,0).rotate(Mem->MyBodyAng()+KickAngle) 
					    ,Mem->MyPos())*2;
    if(!Mem->NumOpponentsWithin(Mem->SP_kickable_area*2))
	return int(dist>25?25:dist);
    else 
      if(Mem->OpponentPositionValid(Mem->ClosestOpponentToBall())&&
	 Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x>Mem->MyPos().x)
	return 26;
      else
	return 27;
}

AngleDeg  vW_Behaviour::AngleToKickBall()
{
    Vector MyPos=Mem->MyPos();
    Vector pos=Mem->MyPos()+Vector(20,0);
    AngleDeg ziel=Mem->AngleToFromBody(pos);
    if(Mem->NumOpponentsWithin(Mem->SP_kickable_area*2)){
	return Mem->MarkerAngleFromBody(Mem->RM_Their_Goal);
    }
    
    int eval=0;
    eval=Mem->NumOpponentsInCone(1,pos,MyPos)-1;
    pos=Mem->MyPos()+Vector(10,10);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(10,-10);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(0,20);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(0,-20);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    return ziel;
}
	

float vW_Behaviour::DistanceToNextOpponentInCone(float wid_dist_ratio, Vector end, Vector vert)
{
    float distance=100;
    for(int i=2; i<=Mem->SP_team_size; i++){
	if(Mem->OpponentPositionValid(i)){
	    if(IsPointInCone(Mem->PlayerAbsolutePosition(Mem->TheirSide,i), wid_dist_ratio, end, vert)){
		float dist2 = Mem->OpponentDistance(i);
		if(dist2<distance) distance=dist2;
	    }
	}
    }
    return distance;
};
