#ifndef VW_BEHAVIOUR_H
#define VW_BEHAVIOUR_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
// #include "../baynet/netica/Netica.h"
#include <stdarg.h>

class vW_Behaviour
{
 public:
    bool organizer;

 protected:
    int inSmartKick;
    float DistanceToNextOpponentInCone(float wid_dist_ratio, Vector end, Vector vert);
    int NumOpponentsInDistance(float Dist);
    int NumTeammatesInDistance(float Dist);
    AngleDeg AngleToKickBall();
    int kickPower(AngleDeg KickAngle);
    bool InZone1_Mode1(Vector Pos);
    bool InZone2_Mode1(Vector Pos);
    bool InZone3_Mode1(Vector Pos);
    bool InZone4_Mode1(Vector Pos);
    bool InZone5_Mode1(Vector Pos);
    bool InZone6_Mode1(Vector Pos);

    bool InZone1_Mode2(Vector Pos);
    bool InZone2_Mode2(Vector Pos);
    bool InZone3_Mode2(Vector Pos);
    bool InZone4_Mode2(Vector Pos);
    bool InZone5_Mode2(Vector Pos);
    bool InZone6_Mode2(Vector Pos);

    Vector MyStartPosition;
    Vector MyStandardPosition;
    Vector SearchBallPosition; 
    Unum findTeammateToPassBall(int evalBase=100);
    Vector BestPositionToReceiveBall;
    Vector GoodPositionToReceiveBall(int x=0);
    int goodPointToScore();
    void Score();
    inline int evaluateTeammateToPassBall(Vector pos,Unum Player);
    int evaluatePointToPassBallFromPoint(Vector pos,Vector Position);
    float PassToTeammateKickPower(Unum Player);
    void go_to_point_backward(Vector pt, float dash_power);
    int GoToPointFaceBall(Vector Point, float DashPower=50,float buff=1);
    int GoToPointFaceOpponent(Vector Point, Unum Player, float DashPower=50,float buff=1);
    void searchBall(int walk=20);
    void say(char *msg);
    void organize(char *msg);

    int WhereIsBall(int mode);
    int OpponentsInDistance(float Dist);
    int TeammatesInDistance(float Dist);
    bool BallCatchableForOpponent();
    int MyStaminaArea();
    int OpponentsInShootingCone();
    int OpenGoal();
    int AngleToGoal();
    void kick_in();
    bool reachedPosition;



// bayes-net anfang
/*    net_bn *t1;
    node_bn *pass_t1;
    environ_ns* env; 
    char mesg[MESG_LEN_ns];
    int res;
    void EnterFinding (char* node_name, char* state_name, net_bn* net){
	node_bn* node = NodeNamed (node_name, net);
	state_bn state = StateNamed_bn (state_name, node);
	EnterFinding_bn (node, state);
    };
    node_bn* NodeNamed (char* node_name, net_bn* net){
	node_bn* node = NodeNamed_bn (node_name, net);
	if (node == NULL)
	  ReportError (env, 0, ERROR_ERR,
		       "NodeNamed: There is no node named '%s' in network '%s'",
		       node_name, GetNetName_bn (net));
	return node;
  };
    report_ns* ReportError (environ_ns* env, int number, errdanger_ns danger, const char* mesg, ...){
	va_list ap;
	char buf[400];
	va_start (ap, mesg);
	vsprintf (buf, mesg, ap);
	va_end (ap);
	return  ReportError_ns (env, number, danger, buf);
    };
*/
// bayes net ende


 public:

    float shoot_chance; //Wahrscheinlichkeit eines erfolgreichen Torschusses
    float pass_chance;  //Wahrscheinlichkeit eines erfolgreichen nutzenbringenden Passes
    float run_chance;   //Wahrscheinlichkeit eines erfolgreichen nutzenbringenden Laufens

    float HearedBallconf;
    float HearedBalldist;
    float defense_line;
    
    bool newMessage;
    Vector HearedBallPosition;
    Vector LeadingPlayerPosition;
    Unum   LeadingPlayerNumber;
    char MyName[16];

    vW_Behaviour(bool _organizer = false);
    virtual ~vW_Behaviour();

    virtual void Behave();

    int NextAction();
/*    float get_shoot_chance(); //wird von uns nicht benutzt kann aber von anderen benutzt werden(noch nicht implementiert)
float get_pass_chance();  //wird von uns nicht benutzt kann aber von anderen benutzt werden(noch nicht implementiert)
float get_run_chance();   //wird von uns nicht benutzt kann aber von anderen benutzt werden(noch nicht implementiert)*/

    //Die einzelnen Wahrscheinlichkeiten
    void shoot_AngleToGoal();
    void shoot_OpenGoal();
    void shoot_OpponentInCone();
    void pass_TeammatesCount();
    void stamina();
    void stateGoalie();
    void OpponentsInDistance();
    void zone ();
};

#endif // VW_BEHAVIOUR_H




