#include "vW_mittelfeld.h"

void Mittelfeld::Behave()
{
    if (!Mem->MyConf()) {
	Mem->LogAction2(10, "Don't know where I am, scanning field");
	scan_field_with_body();
	return;
    }
    
    if (Mem->BallPositionValid())
    {
	/* Ist der Ball spielbar und kann nicht erfolgsversprechend aufs
	   gegenerische Tor geschossen werden, 
	   wird entweder zu einem  besser stehenden Mitspieler gepasst, 
	   oder der Ball vorgelegt und hinterher gerannt */
	
	if (Mem->MyNumber == 
	    Mem->ClosestTeammateTo(Mem->BallAbsolutePosition()))
	{
	    say("");
	}
	if (Mem->BallKickable() )
	{
	    if (Mem->BallMoving())
	    {
		if (!vorgelegt)
		{
		    if (Mem->team_receiver == Mem->MyNumber) {
			stop_ball();
		    } else {
			stop_ball();
		    }
		} else {
		    if (vorgelegt_Time < Mem->CurrentTime-5) 
		    {
			stop_ball();
		    } 
		}
	    }
	    if(goodPointToScore())
	    {
		vorgelegt=false;
		Score();
		return;
	    }
	    int TeammateToPassBall=findTeammateToPassBall(75);
	    if(TeammateToPassBall)
	    {
		vorgelegt=false;
		pass_ball(TeammateToPassBall);
		return;
	    }
	    vorgelegt_Time = Mem->CurrentTime-5;
	    vorgelegt=true;
	    if(Mem->BallAbsolutePosition().x>Mem->MyPos().x){
		if (should_dribble()) {
		    if (lazy_dribbling()) 
			SmartDribbleTo(PointToDribbleTo(),100,1, DM_Lazy);
		    else
		      //DribbleTo(PointToDribbleTo(),75,1,5, DM_Strict);
		      SmartDribbleTo(PointToDribbleTo(),75,1, DM_Strict);
		} else {
		    AngleDeg KickAngle=AngleToKickBall();
		    int Power=kickPower(KickAngle);
		    kick(Power,KickAngle);
		}
	    } else {
		DribbleRes res = SimpleDribbleTo(Mem->TheirRightGoalKickSpot);
		if(res ==  DR_GotThere)
		    kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	    }
	}
	/* Ist der ballnaechste Spieler auf unserer Seite gilt das 
       Offensiv-Verhalten, ansonsten Defensiv-Verhalten */
	
	if(Mem->PlayMode == PM_My_Goal_Kick ||
	   (Mem->SideOfClosestPlayerTo(Mem->BallAbsolutePosition())
	    ==Mem->MySide) ||
	   ((Mem->team_passer == Mem->MyNumber) && 
	    (Mem->team_pass_time > Mem->CurrentTime-100) && 
	    (!Mem->PlayerWithBall()<0)))
	    Offense();
	else
	    Defense();
    } 
    else 
	scan_field_with_body();
    
}


void Mittelfeld::Offense()
{
  if(Mem->PlayMode!=PM_My_Goalie_Free_Kick&&
     (Mem->NumTeammatesCloserToBall()<1|| Mem->team_receiver==Mem->MyNumber)){
    get_ball();
  } else {
    vorgelegt=false;
    Mem->update_offside_lines();
    if(Mem->my_offside_line<Mem->MyPos().x){
      if(Mem->PlayMode!=PM_Play_On)
	go_to_point(Mem->MyPos()-Vector(5,0),0,25,DT_none);
      else
	  go_to_point(Mem->MyPos()-Vector(10,0),0,100,DT_none);
    }else{
      BestPositionToReceiveBall=GoodPositionToReceiveBall(-10);
      if(fabs(BestPositionToReceiveBall.dist(Mem->MyPos())>5)){
	if(!Mem->BallPositionValid()) scan_field_with_neck();
	else
	  face_only_neck_to_ball();
	go_to_point(BestPositionToReceiveBall,0,50,DT_none);
      } else {
	face_neck_and_body_to_ball();
      }
    } 
  }
 
/* Freilaufen */
    /* Immer 10 vor dem Ball herlaufen, es sei denn man steht 5 vor
       der Torauslinie oder im Abseits */
    
    //   Vector temp((Mem->MyPos().x+5),Mem->MyPos().y);
    
    //    if(Mem->FieldRectangle.IsWithin(temp) && 
    //     Mem->OffsidePosition(Mem->MyPos(), Mem->MySide)) 
    //{
    
    //if(Mem->BallAbsolutePosition().x+5 > Mem->MyPos().x)
    //	    GoToPointFaceBall(Vector(Mem->BallAbsolutePosition().x+5, 
    //			     MyStartPosition.y));
    //    go_to_point(Vector(Mem->BallAbsolutePosition().x+5, MyStartPosition.y),
    //		0.1, 50, DT_none);
    
   //else
    //    face_neck_and_body_to_ball();  
    //}
}

void Mittelfeld::Defense() 
{ 
  vorgelegt=false;
  if (Mem->BallPositionValid()) {
    /* Pressing */
    /* Wenn nur ein Mitspieler naeher am Ball ist, dann mit drauf gehen */
    if (Mem->NumTeammatesCloserToBall()<2||
	(!Mem->NumTeammatesInCone(1,Mem->MyPos(),Mem->BallAbsolutePosition())))
      get_ball();
    
    /* Wenn zwar genug Mitspieler naeher am Ball sind, der ballfuehrende
       Gegner aber naeher zu unserem Tor steht, kann es sein, dass die
       beiden Mitspieler bis zum Tor hinterherhecheln
       Ist das so, dann soll der Mittelfeldspieler dem Ball entgegengehen, 
       wenn er denn zwischen Ball und unserem Tor steht und kein Mitspieler 
       sich in dem Kegel zwischen Tor und Gegner aufhaelt.*/
    
    else
      {
	if ((Mem->OpponentPositionValid(Mem->ClosestOpponentToBall()))
	    &&
	    (Mem->TeammatePositionValid(Mem->ClosestTeammateToBall()))
	    &&
	    (Mem->TeammateAbsolutePosition(Mem->ClosestTeammateToBall()).x>
	     Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x) 
	    && 
	    (Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x>
	     Mem->MyPos().x) 
	    &&
	    (Mem->NumTeammatesInCone(2,Mem->MarkerPosition(Mem->RM_My_Goal),
				     Mem->OpponentAbsolutePosition(
					 Mem->ClosestOpponentToBall())))==0
	    ) 
	    get_ball();
	else 
	  //	    GoToPointFaceBall(Vector(Max(Mem->BallAbsolutePosition().x-10,-20),
	  //			     MyStartPosition.y));
	  go_to_point(Vector(Max(Mem->BallAbsolutePosition().x-5,-20),
			     MyStartPosition.y),
		      0.1, 50, DT_none);
	
      }
  } else {
    scan_field_with_body();
  }
}

bool Mittelfeld::lazy_dribbling(){
    if(Mem->NumOpponentsInCone(5,Mem->MyPos()+Vector(5,0),Mem->MyPos()))
	return false;
    else
	return true;
}

bool Mittelfeld::should_dribble(){
    if(Mem->TheirPenaltyArea.IsWithin(Mem->MyPos())||
       Mem->MyPos().x>Mem->MarkerX(Mem->RM_Their_PC_Flag)||
       (Mem->NumOpponentsWithin(20,60,0,0)&&!Mem->NumOpponentsWithin(Mem->SP_kickable_area*2)))
	return true;
    else
	return false;
}

Vector Mittelfeld::PointToDribbleTo(){
  Vector MyPos=Mem->MyPos();
  Vector pos=Mem->MyPos()+Vector(20,0);
  Vector ziel=pos;
  int eval=0;
  eval=Mem->NumOpponentsInCone(1,pos,MyPos)-1;
  pos=Mem->MyPos()+Vector(10,10);
  if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
    eval=Mem->NumOpponentsInCone(1,pos,MyPos);
    ziel=pos;
  }
  pos=Mem->MyPos()+Vector(10,-10);
  if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
    eval=Mem->NumOpponentsInCone(1,pos,MyPos);
    ziel=pos;
    
  }
  pos=Mem->MyPos()+Vector(0,20);
  if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
    eval=Mem->NumOpponentsInCone(1,pos,MyPos);
    ziel=pos;
    
  }
  pos=Mem->MyPos()+Vector(0,-20);
  if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
    eval=Mem->NumOpponentsInCone(1,pos,MyPos);
    ziel=pos;
    
  }
  return ziel;
}
  

void Herzog::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	OMittelfeld::Behave();
    }
}


void Bode::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	OMittelfeld::Behave();
    }
}


void Maximov::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	OMittelfeld::Behave();
    }
}


void Schierenbeck::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	Mittelfeld::Behave();
    }
}


void Trares::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	
	    DMittelfeld::Behave();
    }
}


void Frey::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	DMittelfeld::Behave();
    }
}

void Eilts::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	DMittelfeld::Behave();
    }
}

void Dabrowski::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	Mittelfeld::Behave();
    }
}

void OMittelfeld::Behave()
{
    if (!Mem->MyConf()) {
	Mem->LogAction2(10, "Don't know where I am, scanning field");
	scan_field_with_body();
	return;
    }	
    if (Mem->BallPositionValid())
    {
	/* Ist der Ball spielbar und kann nicht erfolgsversprechend aufs
	   gegenerische Tor geschossen werden, 
	   wird entweder zu einem  besser stehenden Mitspieler gepasst, 
	   oder der Ball vorgelegt und hinterher gerannt */
	
	if (Mem->MyNumber == 
	    Mem->ClosestTeammateTo(Mem->BallAbsolutePosition()))
	{
	    say("");
	}
	if(Mem->PlayMode== PM_My_Kick_In){
	    if(Mem->MyNumber == Mem->ClosestTeammateToBall())
		kick_in();
	    else 
		Offense();
	    return;
	}
	if (Mem->BallKickable() )
	{
	    BallWithMe();
	} else {
	    
	    /* Ist der ballnaechste Spieler auf unserer Seite gilt das 
	       Offensiv-Verhalten, ansonsten Defensiv-Verhalten */
	    
	    if(Mem->PlayMode == PM_Play_On ||
	       (Mem->SideOfClosestPlayerTo(Mem->BallAbsolutePosition())
		==Mem->MySide) ||
	       ((Mem->team_passer == Mem->MyNumber) && 
		(Mem->team_pass_time > Mem->CurrentTime-100) && 
		(!Mem->PlayerWithBall()<0)))
		Offense();
	    else
		Defense();
	}
    }
    else 
	scan_field_with_body();
    
}

void OMittelfeld::BallWithMe()
{
  Mem->team_receiver=0; 
    if(goodPointToScore())
    {
	Score();
	return;
    }
    if(Mem->OpponentPositionValid(Mem->ClosestOpponentToBall())&& 
       Mem->BallKickableForOpponent(Mem->ClosestOpponentToBall())){
	kick_ball(Mem->MarkerAngleFromBody(Mem->RM_Their_Goal),
		  KM_QuickestRelease);
	return;
    }
    if (Mem->BallVelocityValid() && Mem->BallAbsoluteVelocity().mod()>2&&!vorgelegt)
    {
	stop_ball();
    } else {
	int TeammateToPassBall=findTeammateToPassBall(50);
	if(TeammateToPassBall)
	{
	    pass_ball(TeammateToPassBall);
	    return;
	}   
	if(Mem->MyPos().x>40&&fabs(Mem->MyPos().y)>20){
	    vorgelegt=false;
	    kick_ball(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag),
		      Mem->BestKickMode(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag)));
	    return;
	}
	vorgelegt_Time = Mem->CurrentTime-5;
	vorgelegt=true;
	if(Mem->BallAbsolutePosition().x>Mem->MyPos().x){
	    if (should_dribble()) {
		if (lazy_dribbling()) 
		  DribbleTo(PointToDribbleTo(),100,1,5, DM_Lazy);
		else
		  // DribbleTo(PointToDribbleTo(),75,1,5, DM_Strict);
		  SmartDribbleTo(PointToDribbleTo(),75,1);
	    } else {
		AngleDeg KickAngle=AngleToKickBall();
		int Power=kickPower(KickAngle);
		if(Power==26)
		  kick(10,Mem->AngleToFromBody(Vector(Mem->MyPos().x,-Mem->MyPos().y)));
		else{
		  if(Power==27)
		    kick(25,0);
		  else{
		    kick(Power,KickAngle);
		    scan_field_with_neck();
		  }
		}
		
	    }
	}else{
	    DribbleRes res = SimpleDribbleTo(Mem->TheirRightGoalKickSpot);
	    if(res ==  DR_GotThere)
		kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	}
    }
}



void OMittelfeld::Offense()
{
  Mittelfeld::Offense();
}

void OMittelfeld::Defense()
{
    vorgelegt = false;
    Vector mypos = Mem->MyPos();
    //wenn nicht in der eigenen Haelfte, sollte das "normale" Verhalten reichen
    if(!mypos.x<0) {
	Mittelfeld::Defense();
	return;
    } else {
	Unum fastestTeammate = Mem->FastestTeammateToBall();
	if (Mem->TeammatePositionValid(fastestTeammate)) {
	    if (fastestTeammate == Mem->MyNumber) 
		get_ball();
	    else {
		if (Mem->TeammateAbsolutePosition(fastestTeammate).x > mypos.x+10){
		    if (Mem->BallPositionValid()) 
			GoToPointFaceBall(Vector(mypos.x+5, mypos.y));
		    else 
			scan_field_with_body();
		} else {
		    Mittelfeld::Defense();
		    return;
		}
	    }
	} else {
	    if (Mem->BallPositionValid()) 
		get_ball();
	    else 
		scan_field_with_body();
	}
    }
}



void  DMittelfeld::Offense()
{
  if (Mem->MyPos().x<0) {
    Mittelfeld::Offense();
  } else {
    if(Mem->PlayMode!=PM_My_Goalie_Free_Kick&&
       (Mem->NumTeammatesCloserToBall()<1|| Mem->team_receiver==Mem->MyNumber)){
      get_ball();
    } else {
      vorgelegt = false;
      scan_field_with_neck();
      if (Mem->my_offside_line>=Mem->MyPos().x) {
	BestPositionToReceiveBall=Vector(Mem->BallAbsolutePosition().x-5,
					 Mem->BallAbsolutePosition().y+(MyStartPosition.y/2));
	  if(fabs(BestPositionToReceiveBall.dist(Mem->MyPos())>2)&&
	     (Mem->FieldRectangle.IsWithin(BestPositionToReceiveBall))){
	    if(!Mem->BallPositionValid()) scan_field_with_neck();
	    else
	      face_only_neck_to_ball();
	    if(BestPositionToReceiveBall.x<Mem->MyPos().x)
	      go_to_point(BestPositionToReceiveBall,0,75,DT_none);
	    else
	      go_to_point(BestPositionToReceiveBall,0,25,DT_none);
	  } else {
	    face_neck_and_body_to_ball();
	  }
      } else {
	/* Wenn ich mich im Abseits befinde, sollte ich zum naechstmoeglichen
	   Anspielpunkt laufen. */
	if(Mem->PlayMode!=PM_Play_On)
	  go_to_point(Mem->MyPos()-Vector(5,0),0,25,DT_none);
	else
	  go_to_point(Mem->MyPos()-Vector(10,0),0,100,DT_none);
      }
    }
  }
}

    
	

void DMittelfeld::Behave()
{
    if (!Mem->MyConf()) {
	Mem->LogAction2(10, "Don't know where I am, scanning field");
	scan_field_with_body();
	return;
    }
    
    if (Mem->BallPositionValid())
    {
	/* Ist der Ball spielbar und kann nicht erfolgsversprechend aufs
	   gegenerische Tor geschossen werden, 
	   wird entweder zu einem  besser stehenden Mitspieler gepasst, 
	   oder der Ball vorgelegt und hinterher gerannt */
	
	if (Mem->MyNumber == 
	    Mem->ClosestTeammateTo(Mem->BallAbsolutePosition()))
	{
	  say("");
	}
	if(Mem->PlayMode== PM_My_Kick_In){
	    if(Mem->MyNumber == Mem->ClosestTeammateToBall())
		kick_in();
	    else 
		Offense();
	    return;
	}
	if (Mem->BallKickable())
	{
	    BallWithMe();
	} else {
	    
	    
	    /* Ist der ballnaechste Spieler auf unserer Seite gilt das 
	       Offensiv-Verhalten, ansonsten Defensiv-Verhalten */
	    
	    if(!Mem->PlayerWithBall()>0 ||
	       Mem->PlayMode != PM_Play_On ||
	       ((Mem->team_passer == Mem->MyNumber) && 
		(Mem->team_pass_time > Mem->CurrentTime-100) && 
		(!Mem->PlayerWithBall()<0)))
		Offense();
	    else
		Defense();
	}
    } else
	scan_field_with_body();
}


void DMittelfeld::BallWithMe()
{
  Mem->team_receiver=0;

    if(goodPointToScore())
    {
	Score();
	return;
    }
    if(Mem->OpponentPositionValid(Mem->ClosestOpponentToBall())&& 
       Mem->BallKickableForOpponent(Mem->ClosestOpponentToBall())){
	kick_ball(Mem->MarkerAngleFromBody(Mem->RM_Their_Goal),
		  KM_QuickestRelease);
	return;
    }
    if (Mem->BallVelocityValid() && Mem->BallAbsoluteVelocity().mod()>2&&!vorgelegt)
    {
	stop_ball();
    } else {
	int TeammateToPassBall=findTeammateToPassBall(50);
	if(TeammateToPassBall)
	{
	    vorgelegt=false;
	    pass_ball(TeammateToPassBall);
	    return;
	} 
	if(Mem->MyPos().x>40&&fabs(Mem->MyPos().y)>20){
	    vorgelegt=false;
	    kick_ball(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag),
		      Mem->BestKickMode(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag)));
	    return;
	}
	
	vorgelegt_Time =Mem->CurrentTime;
	vorgelegt=true;
	if(Mem->BallAbsolutePosition().x>Mem->MyPos().x){
	    if (should_dribble()) {
		if (lazy_dribbling()) 
		    DribbleTo(PointToDribbleTo(),100,1,5, DM_Lazy);
		else
		    DribbleTo(PointToDribbleTo(),75,1,5, DM_Strict);    
		    //SmartDribbleTo(PointToDribbleTo(),75);
	    } else {
		AngleDeg KickAngle=AngleToKickBall();
		int Power=kickPower(KickAngle);
		if(Power==26)
		  kick(10,Mem->AngleToFromBody(Vector(Mem->MyPos().x,-Mem->MyPos().y)));
		else{
		  if(Power==27)
		    kick(25,0);
		  else{
		    kick(Power,KickAngle);
		    scan_field_with_neck();
		  }	    
		}
	    }
	}else{
	    DribbleRes res = SimpleDribbleTo(Mem->TheirRightGoalKickSpot);
	    if(res ==  DR_GotThere)
		kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	}
    }
}


void DMittelfeld::Defense() 
{ 
  vorgelegt=false;
  if (Mem->BallPositionValid()) {
    /* Pressing */
    /* Wenn nur ein Mitspieler naeher am Ball ist, dann mit drauf gehen */
    if (Mem->NumTeammatesCloserToBall()<2)
	get_ball();

    /* Wenn zwar genug Mitspieler naeher am Ball sind, der ballfuehrende
       Gegner aber naeher zu unserem Tor steht, kann es sein, dass die
       beiden Mitspieler bis zum Tor hinterherhecheln
       Ist das so, dann soll der Mittelfeldspieler dem Ball entgegengehen, 
       wenn er denn zwischen Ball und unserem Tor steht und kein Mitspieler 
       sich in dem Kegel zwischen Tor und Gegner aufhaelt.*/

    else
    {
	if (Mem->MyPos().x<Mem->MarkerPosition(Mem->RM_Their_PC_Flag).x&&
	    Mem->OpponentPositionValid(Mem->ClosestOpponentToBall()) &&
	    Mem->TeammatePositionValid(Mem->ClosestTeammateToBall()) &&
	    (Mem->TeammateAbsolutePosition(Mem->ClosestTeammateToBall()).x>
	     Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x) && 
	    (Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x>
	     Mem->MyPos().x) &&
	    (Mem->NumTeammatesInCone(2,Mem->MarkerPosition(Mem->RM_My_Goal),
				     Mem->OpponentAbsolutePosition(
					 Mem->ClosestOpponentToBall())))==0
	    ) 
	    get_ball();
	else 
	    if(Mem->FieldRectangle.IsWithin(Vector(Mem->BallAbsolutePosition().x-5,
						   Mem->BallAbsolutePosition().y+(MyStartPosition.y/2))))
		go_to_point(Vector(Mem->BallAbsolutePosition().x-5,
				   Mem->BallAbsolutePosition().y+(MyStartPosition.y/2)),
			    0.1, 75, DT_none);
	
    }
  } else {
    if (Mem->MyPos().x>0) go_to_point(Vector(Mem->MyPos().x-5, Mem->MyPos().y));
    scan_field_with_body();
  }
}

Vector DMittelfeld::GoodPositionToReceiveBall(int x){
    Vector Ball = Mem->BallAbsolutePosition();
    int eva =(evaluatePointToPassBallFromPoint(BestPositionToReceiveBall,
					       Ball)	
	      -(int)fabs(BestPositionToReceiveBall.y-MyStartPosition.y)*10
	      -200*Mem->NumTeammatesWithin(15,BestPositionToReceiveBall)
	      -((int)(fabs((BestPositionToReceiveBall.x-Ball.x)-x))*20)
	      - (int) (BestPositionToReceiveBall.x-defense_line)*50);
    Vector Position = BestPositionToReceiveBall;
    if(BestPositionToReceiveBall.x>Mem->my_offside_line) BestPositionToReceiveBall.x=Mem->my_offside_line;
    if(BestPositionToReceiveBall.x<defense_line) BestPositionToReceiveBall.x=defense_line;
    for(int i=0;i<80;i++){
	Vector temp(Position.x+(random()%60)-30,Position.y+(random()%60)-30);
	if(temp.x>Mem->my_offside_line) temp.x=Mem->my_offside_line;
        if(temp.x<defense_line) temp.x=defense_line;
	int evatemp=(evaluatePointToPassBallFromPoint(temp,Ball)
		     -(int)fabs(temp.y-MyStartPosition.y)*10
		     -200*Mem->NumTeammatesWithin(15,temp)
		     -((int)(fabs((temp.x-Ball.x)-x))*20)
		     - (int) (temp.x-defense_line)*50);
	if(Mem->FieldRectangle.IsWithin(temp)&& eva < evatemp){
	    eva=evatemp;
	    Position=temp;
	}
    }    
    // cerr <<Position.x << ":"<< Position.y<<endl;
    return Position;
}

    
