#ifndef _VW_torhueter_H_
#define _VW_torhueter_H_

class vW_Goalkeeper : public vW_Behaviour {
 public:
  void Behave();
 protected:
  void stand_between_Ball_and_Goal();
  void stand_between_predicted_Ball_and_Goal();
  Bool isTeammateBetweenBallAndMe();
  bool  perform_kick_off;
  bool  after_kick_off;
  int   kickcounter;
  int   bakocounter;
  int   goalkickcounter;
  Vector MyFavoritePoint;
  Vector MyFavoritePointL;
  Vector MyFavoritePointR;
  Vector MyKickInLeft;
  Vector MyKickInRight;
  Vector MyCornerLeft;
  Vector MyCornerRight;
  Vector MyGoalLeft;
  Vector MyGoalRight;
  void gotoPredictedBallPosition();
  void initiate_cool_kick_off();
  void execute_cool_kick_off();
  void behave_after_kick_off();
  void behave_on_kick_in();
  void behave_on_their_corner_kick();
  void behave_on_my_goal_kick();
  void behave_default();
  float calc_angle_relative_to(Vector v1, Vector v2);
  float calc_attack_angle(Unum unum);
  float calc_intercept_angle(Unum unum);
  float calc_intercept_angle(Vector v);
  float calc_opt_intercept_angle(Vector v);
  Vector calc_opt_intercept_position(Vector v);
  int TeammateToPassBall;
  float GOAL_DEFEND_ZONE;
  float GOAL_CENTER_RANGE;
  float GOAL_MID_RANGE;
  float GOAL_KICK_DIST;
  float GOAL_NEARLY_HIT;
  float GOAL_KICK_REACHABLE;
  float GOAL_KICK_UNREACHABLE;
  float KICK_OFF_TEAM_DIST;
  float KICK_IN_NEARBY;
  int   WAIT_KICK_OFF_1;
  int   WAIT_KICK_OFF_2;
  int   WAIT_KICK_OFF_3;
  int   GOAL_KICK_MOVER;
 public:
  vW_Goalkeeper()
    {
      perform_kick_off = FALSE;  // true if still in execute mode for goalie kick off
      after_kick_off   = FALSE;  // true if goalie kick off was executed
      kickcounter      = 0;      // 
      bakocounter      = 0;
      goalkickcounter  = 0;
      TeammateToPassBall = Unum_Unknown; // 
      MyFavoritePoint  = Vector((-Mem->SP_pitch_length/2)+3.5f,0);
      MyFavoritePointL = MyFavoritePoint+Vector(0,Mem->SP_goal_width/2-3);
      MyFavoritePointR = MyFavoritePoint+Vector(0,-Mem->SP_goal_width/2+3);
      MyKickInLeft     = Vector((-Mem->SP_pitch_length/2)+Mem->SP_penalty_area_length-2,
				Mem->SP_penalty_area_width/2-2);
      MyKickInRight    = Vector((-Mem->SP_pitch_length/2)+Mem->SP_penalty_area_length-2,
				-Mem->SP_penalty_area_width/2+2);
      MyGoalLeft       = Vector((-Mem->SP_pitch_length/2),Mem->SP_goal_width/2);
      MyGoalRight      = Vector((-Mem->SP_pitch_length/2),-Mem->SP_goal_width/2);
      MyCornerLeft     = MyGoalLeft+Vector(1.0f,-1.0f);
      MyCornerRight    = MyGoalRight+Vector(1.0f,1.0f);

      GOAL_DEFEND_ZONE      =  20;   // 20m dist to ball will turn goalie active
      GOAL_CENTER_RANGE     =  20;   // conus within goalie is in mid-attack defense mode  
      GOAL_MID_RANGE        =  40;   // conus within goalie is in side-attack defense mode
      GOAL_KICK_DIST        =  3.3f; // ball not far enough to intercept on a line 
      GOAL_NEARLY_HIT       =  2.0f; 
      WAIT_KICK_OFF_1       =  25;   // cycles waiting after catch 
      WAIT_KICK_OFF_2       =  25;   // cycles waiting after move
      WAIT_KICK_OFF_3       =  10;    // cycles denied to go to ball after a goalie kick off
      GOAL_KICK_REACHABLE   =  5;    // 
      GOAL_KICK_UNREACHABLE =  1;    //
      KICK_OFF_TEAM_DIST    =  20.0f;// 20m dist from kick off points
      KICK_IN_NEARBY        =  -Mem->SP_pitch_length/2; // dist ball from goal
      GOAL_KICK_MOVER       = 0;
    };
};


class Rost : public vW_Goalkeeper { 
 public:
 protected:
};

class Brasas : public vW_Goalkeeper { // der wird implementiert...
 public:
    void Behave();
 protected:
};

class Borel : public vW_Goalkeeper {
 public:
    void Behave();
 protected:
};

#endif

