
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "Memory.h"
#include "geometry.h"
#include "test.h"
#include "client.h"
#include "kick.h"
#include "dribble.h"
#include "behave.h"
#include "vW_tactics.h"

#include "virtualWerder.h"

// Spezialverhalten
#include "vW_torhueter.C"
#include "vW_stuermer.C"
#include "vW_abwehr.C"
#include "vW_mittelfeld.C"

vW_Behaviour *ChoosePlayerBehaviour(int number)
{
  vW_Behaviour *newBehaviour;

  switch(Mem->Formation)
  {
  case NT_MANIACALOFFENSIVE:
      switch(number)
      {  
          // === Beschreibung ===
	  // 0(1)-5-5 MANIACALOFFENSIVE
      case 1:
//	  newBehaviour=new Rost;
	  newBehaviour=new Brasas;
	  break; 
      case 2: 
	  newBehaviour=new Trares;
	  break; 
      case 3:
	  newBehaviour=new Frey;
	  break; 
      case 4:
	  newBehaviour=new Bode;
	  break;
      case 5:
	  newBehaviour=new Herzog;
	  break; 
      case 6: 
	  newBehaviour=new Maximov;
	  break; 
      case 7: 
	  newBehaviour=new Frings;
	  break; 
      case 8:
	  newBehaviour=new Pizarro;
	  break; 
      case 9:
	  newBehaviour=new Bogdanovic;
	  break; 
      case 10:
	  newBehaviour=new Ailton;
	  break;
      case 11: 
	  newBehaviour=new Stalteri;
	  break; 
	  
      default: 
	  newBehaviour=new vW_Behaviour;
      }
      break;
  case NT_VERYOFFENSIVE:
      switch(number)
      {  
          // === Beschreibung ===
	  // 2-3-5 VERYOFFENSIVE
      case 1:
	  newBehaviour=new Brasas;
	  break; 
      case 2:
	  newBehaviour=new Barten;
	  break; 
      case 3: 
	  newBehaviour=new Baumann;
	  newBehaviour->organizer=true;
	  break; 
      case 4:
	  newBehaviour=new Eilts;
	  break;
      case 5:
	  newBehaviour=new Bode;
	  break; 
      case 6: 
	  newBehaviour=new Maximov;
	  break; 
      case 7: 
	  newBehaviour=new Frings;
	  break; 
      case 8:
	  newBehaviour=new Pizarro;
	  break; 
      case 9:
	  newBehaviour=new Bogdanovic;
	  break; 
      case 10:
	  newBehaviour=new Ailton;
	  break;
      case 11: 
	  newBehaviour=new Stalteri;
	  break; 
	  
      default: 
	  newBehaviour=new vW_Behaviour;
      }
      break;
  case NT_OFFENSIVE:
      switch(number)
      {
	  // === Beschreibung ===
	  // 3-3-4 OFFENSIVE
      case 1:
	  newBehaviour=new Brasas;
	  break; 
      case 2: 
	  newBehaviour=new Thiago;
	  break; 
      case 3:
	  newBehaviour=new Verlaat;
	  newBehaviour->organizer=true;
	  break; 
      case 4:
	  newBehaviour=new Krstajic;
	  break;
      case 5:
	  newBehaviour=new Eilts;
	  break; 
      case 6: 
	  newBehaviour=new Bode;
	  break; 
      case 7: 
	  newBehaviour=new Maximov;
	  break; 
      case 8:
	  newBehaviour=new Frings;
	  break;
      case 9:
	  newBehaviour=new Pizarro;
	  break; 
      case 10:
	  newBehaviour=new Ailton;
	  break; 
      case 11: 
	  newBehaviour=new Stalteri;
	  break; 
      
      default: 
	  newBehaviour=new vW_Behaviour;
      } 
      break;
  case NT_MEDIUM:
      switch(number)
      {
	  // === Beschreibung ===
	  // 3-4-3 MEDIUM
      case 1:
	  newBehaviour=new Brasas;
	  break; 
      case 2: 
	  newBehaviour=new Thiago;
	  break; 
      case 3:
	  newBehaviour=new Verlaat;
	  newBehaviour->organizer=true;
	  break; 
      case 4:
	  newBehaviour=new Krstajic;
	  break;
      case 5:
	  newBehaviour=new Trares;
	  break; 
      case 6: 
	  newBehaviour=new Frey;
	  break; 
      case 7: 
	  newBehaviour=new Bode;
	  break; 
      case 8:
	  newBehaviour=new Maximov;
	  break;
      case 9:
	  newBehaviour=new Frings;
	  break; 
      case 10:
	  newBehaviour=new Bogdanovic;
	  break; 
      case 11: 
	  newBehaviour=new Stalteri;
	  break; 
      
      default: 
	  newBehaviour=new vW_Behaviour;
      } 
      break;
  case NT_DEFENSIVE:
      switch(number)
      {
	  // === Beschreibung ===
	  // 4-3-3 DEFENSIVE
      case 1:
	  newBehaviour=new Brasas;
	  break;
      case 2:
	  newBehaviour=new Thiago;
	  break;
      case 3:
	  newBehaviour=new Barten;
	  break;
      case 4:
	  newBehaviour=new Baumann;
	  newBehaviour->organizer=true;
	  break;
      case 5:
	  newBehaviour=new Krstajic;
	  break;
      case 6:
	  newBehaviour=new Trares;
	  break;
      case 7:
	  newBehaviour=new Frey;
	  break;
      case 8:
	  newBehaviour=new Herzog;
	  break;
      case 9:
	  newBehaviour=new Frings;
	  break;
      case 10:
	  newBehaviour=new Stalteri;
	  break;
      case 11:
	  newBehaviour=new Bogdanovic;
	  break;
      
      default:
	  newBehaviour=new vW_Behaviour;
      }
      break;
  case NT_VERYDEFENSIVE:
      switch(number)
      {
	  // === Beschreibung ===
	  // 5-4-1 VERYDEFENSIVE
      case 1:
	  newBehaviour=new Brasas;
	  break;
      case 2:
	  newBehaviour=new Thiago;
	  break;
      case 3:
	  newBehaviour=new Barten;
	  break;
      case 4:
	  newBehaviour=new Verlaat;
	  newBehaviour->organizer=true;
	  break;
      case 5:
	  newBehaviour=new Baumann;
	  break;
      case 6:
	  newBehaviour=new Krstajic;
	  break;
      case 7:
	  newBehaviour=new Eilts;
	  break;
      case 8:
	  newBehaviour=new Bode;
	  break;
      case 9:
	  newBehaviour=new Herzog;
	  break;
      case 10:
	  newBehaviour=new Maximov;
	  break;
      case 11:
	  newBehaviour=new Bogdanovic;
	  break;
      
      default:
	  newBehaviour=new vW_Behaviour;
      }
      break;
  case NT_CEMENTMIXER:
      switch(number)
      {
	  // === Beschreibung ===
	  // 7-1-2 CEMENTMIXER
      case 1:
	  newBehaviour=new Brasas;
	  break;
      case 2:
	  newBehaviour=new Tjikuzu;	 
	  break;
      case 3:
	  newBehaviour=new Thiago;
	  break;
      case 4:
	  newBehaviour=new Barten;
	  break;
      case 5:
	  newBehaviour=new Verlaat;
	  newBehaviour->organizer=true;
	  break;
      case 6:
	  newBehaviour=new Baumann;
	  break;
      case 7:
	  newBehaviour=new Krstajic;
	  break;
      case 8:
	  newBehaviour=new Wiedener;
	  break;
      case 9:
	  newBehaviour=new Eilts;
	  break;
      case 10:
	  newBehaviour=new Pizarro;
	  break;
      case 11:
	  newBehaviour=new Ailton;
	  break;
      
      default:
	  newBehaviour=new vW_Behaviour;
      }
      break;
  }
  return(newBehaviour);
}
